<!DOCTYPE html>
<!--[if IE 7]>
<html class="ie ie7" <?php language_attributes(); ?> class="no-js">
<![endif]-->
<!--[if IE 8]>
<html class="ie ie8" <?php language_attributes(); ?> class="no-js">
<![endif]-->
<!--[if !(IE 7) | !(IE 8)  ]><!-->
<html <?php language_attributes(); ?> class="no-js">
<!--<![endif]-->
<head>
<meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1" />
<meta charset="<?php bloginfo( 'charset' ); ?>" />
<title><?php wp_title( '|', true, 'right' ); ?></title>
<link rel="profile" href="http://gmpg.org/xfn/11" />
<link rel="pingback" href="<?php bloginfo( 'pingback_url' ); ?>" />
<?php global $bd_data; ?>
<?php wp_head(); ?>
</head>
<?php
$body_styles = null;
if (is_singular())
{
    $body_styles = "style='";

    if(get_post_meta(get_the_ID(), 'bd_post_background_color', true) && get_post_meta(get_the_ID(), 'bd_post_background_color', true) !='#')
    {
        $body_styles .=   "background:".get_post_meta(get_the_ID(), 'bd_post_background_color', true)." !important;";
    }

    if(get_post_meta(get_the_ID(), 'bd_post_background_custom', true))
    {
        $att_id = get_post_meta(get_the_ID(), 'bd_post_background_custom', true);
        $attachment = wp_get_attachment_image_src( $att_id, 'full' );

        $body_styles .=   "background: ".get_post_meta(get_the_ID(), 'bd_post_background_color', true)." url(".$attachment[0].")".get_post_meta(get_the_ID(), 'bd_post_background_repeat', true)." ".get_post_meta(get_the_ID(), 'bd_post_background_attachment', true)." ".get_post_meta(get_the_ID(), 'bd_post_background_x', true)." ".get_post_meta(get_the_ID(), 'bd_post_background_y', true)." !important;";
    }
    else
    {
    }
    $body_styles .=  "'";

    /*
     * Article Sidebar Position
     */
    if( bdayh_get_option( 'article_sidebar_position', true ) == 'article_sidebar_position_right' )
    {
        $article_sidebar    = ' article_sidebar_position_right';
    }
    elseif( bdayh_get_option( 'article_sidebar_position', true ) == 'article_sidebar_position_left' )
    {
        $article_sidebar    = ' article_sidebar_position_left';
    }
    elseif( bdayh_get_option( 'article_sidebar_position', true ) == 'article_sidebar_position_full' )
    {
        $article_sidebar    = ' article_sidebar_position_full';
    }
}
?>
<body <?php body_class(); echo $body_styles; ?>>
<div id="wrapper" class="<?php if($bd_data['layout_type'] == 'layout_boxed'){ echo 'boxed'; } echo $article_sidebar ?>">
    <?php if(bdayh_get_option('show_top_bar')){ ?>
        <?php
        if(bdayh_get_option('top_bar_color') == 'top_dark'){
            $top_bar_color = " top-dark";
        }
        elseif(bdayh_get_option('top_bar_color') == 'top_light')
        {
            $top_bar_color = " top-light";
        }
        ?>
        <div class="header-topbar top<?php echo $top_bar_color ?>">
            <div class="container">
                <ul class="top-left">
                    <?php if(bdayh_get_option('show_top_social_left')) { ?>
                        <li class="social-area">
                            <div class="social-header">
                                <?php echo bd_social('yes', '', 'tooldown'); ?>
                            </div><!-- social/-->
                        </li>
                    <?php } ?>
                    <?php if(bdayh_get_option('show_top_search_left')) { ?>
                        <li class="search-area">
                            <div class="search-box">
                                <?php get_search_form(); ?>
                            </div>
                        </li>
                    <?php } ?>
                    <?php if(bdayh_get_option('show_top_menu_left')) { ?>
                        <li class="menu-area">
                            <div id="top-navigation">
                                <?php wp_nav_menu(array('theme_location' => 'topmenu', 'depth' => 5, 'container' => false, 'menu_id' => 'menu-top', 'fallback_cb' => 'nav_fallback' ) ); ?>
                            </div>
                        </li>
                    <?php } ?>
                    <?php if(bdayh_get_option('show_top_date_left')) { ?>
                        <li class="date-area">
                            <?php
                            if( bdayh_get_option( 'todaydate_format' ) )
                            {
                                $date_format = bdayh_get_option('todaydate_format');
                            }
                            else
                            {
                                $date_format = 'l ,  j  F Y';
                            }
                            echo '<span class="top-date"> '. date_i18n( $date_format , current_time( "timestamp" ) ) .'</span>';
                            ?>
                        </li>
                    <?php } ?>
                </ul>
                <ul class="top-right">
                    <?php if(bdayh_get_option('show_top_menu_right')) { ?>
                        <li class="menu-area">
                            <div id="top-navigation">
                                <?php wp_nav_menu(array('theme_location' => 'topmenu', 'depth' => 5, 'container' => false, 'menu_id' => 'menu-top' , 'fallback_cb' => 'nav_fallback' ) ); ?>
                            </div>
                        </li>
                    <?php } ?>
                    <?php if(bdayh_get_option('show_top_date_right')) { ?>
                        <li class="date-area">
                            <?php
                            if( bdayh_get_option( 'todaydate_format' ) )
                            {
                                $date_format = bdayh_get_option('todaydate_format');
                            }
                            else
                            {
                                $date_format = 'l ,  j  F Y';
                            }
                            echo '<span class="top-date"> '. date_i18n( $date_format , current_time( "timestamp" ) ) .'</span>';
                            ?>
                        </li>
                    <?php } ?>
                    <?php if(bdayh_get_option('show_top_search_right')) { ?>
                        <li class="search-area">
                            <div class="search-box">
                                <?php get_search_form(); ?>
                            </div>
                        </li>
                    <?php } ?>
                    <?php if(bdayh_get_option('show_top_social_right')) { ?>
                        <li class="social-area">
                            <div class="social-header">
                                <?php echo bd_social('yes', '', 'tooldown'); ?>
                            </div><!-- social/-->
                        </li>
                    <?php } ?>
                </ul>
            </div>
        </div><!-- .top -->
    <?php } ?>
    <div class="header">
        <div class="container">
            <?php if(bdayh_get_option('logo_displays') != 'logo_image'){ $logo_class = " logo-img"; } else { $logo_class = " logo-title"; } ?>
            <div class="logo header-logo<?php echo $logo_class ?>" style="<?php if($bd_data['margin_logo_top']){ ?>margin-top:<?php echo $bd_data['margin_logo_top']; ?>px;<?php } ?><?php if($bd_data['margin_logo_right']){ ?>margin-right:<?php echo $bd_data['margin_logo_right']; ?>px;<?php } ?><?php if($bd_data['margin_logo_bottom']){ ?>margin-bottom:<?php echo $bd_data['margin_logo_bottom']; ?>px;<?php } ?><?php if($bd_data['margin_logo_left']){ ?>margin-left:<?php echo $bd_data['margin_logo_left']; ?>px;<?php } ?>">
                <?php bd_logo(); ?>
            </div><!-- logo/-->
            <?php
            if( bdayh_get_option('show_header_ads') == true )
            {
            	if($bd_data['margin_header_adv_top']){
           			$m_adv_top = 'style="margin-top: '. $bd_data['margin_header_adv_top'] .'px"';
           		}
           		else
           		{
         			$m_adv_top ='';
         		}

                if($bd_data['header_ads_code'] != '')
                {
                    echo '<div class="header-adv">' ."\n";
                    echo stripslashes( $bd_data['header_ads_code'] );
                    echo '</div><!-- .header-adv/-->' ."\n";
                }
                else
                {
                    echo '<div class="header-adv" '. $m_adv_top .'><a href="'.$bd_data['header_ads_img_url'].'" title="'.$bd_data['header_ads_img_altname'].'"><img src="'.$bd_data['header_ads_img'].'" alt="'.$bd_data['header_ads_img_altname'].'" /></a></div><!-- .header-adv/-->' ."\n";
                }
            }
            ?>
        </div>
    </div><!-- .header -->
    <div id="navigation">
        <div class="container">
            <ul id="menu-nav" class="menu">
                <?php wp_nav_menu( array( 'theme_location' => 'primary', 'depth' => 5, 'container' => false, 'menu_id' => 'menu-nav', 'items_wrap' => '%3$s', 'fallback_cb' => 'none' ) ); ?>
            </ul>
        </div>
    </div><!-- #navigation -->
    <?php echo bd_breaking_news(); ?>
    <div class="clear"></div>
<?php
if( is_home() ) {
    if( bdayh_get_option( 'slider_layout' ) == 'full' ) {
        include (get_template_directory().'/includes/slider-full.php');
    }
}
?>
<div id="main" class="container">